package de.unipotsdam.hpi.cind.associationRuleMining.util;

import java.util.*;


public class AssociationRule implements Iterable<String>{

	private ArrayList<String> lhs;
	
	/*
	 * confidence = validity = support(X \cup INCLUDED_TRUE) / support(X)
	 * confidenceBar = totalCompleteness = support(X \cup INCLUDED_TRUE) / support(INCLUDED_TRUE)
	 */
	
	// support(X \cup INCLUDED_TRUE)
	private int lhsRhsSupp;
	// support(X)
	private int lhsSupp ;
	
	
	private double validity, totalCompleteness;
	

	/**
	 * 
	 * @param lhs
	 *            items of left hand side
	 * @param lhsRhsSupp
	 *            support of left hand and right hand sid
	 * @param lhsSupp
	 *            support of left hand side
	 * @param validity
	 *            validity of rule lhs -> Apriori.INCLUDED_TRUE
	 * @param totalCompleteness
	 *            total completeness of rule lhs -> Apriori.INCLUDED_TRUE
	 */
	public AssociationRule(List<String> lhs, int lhsRhsSupp, int lhsSupp, double validity, double totalCompleteness) {
		
		this.lhs = new ArrayList<String>(lhs);
		this.lhsRhsSupp = lhsRhsSupp;
		this.lhsSupp = lhsSupp;
		this.validity = validity;
		this.totalCompleteness = totalCompleteness;
		
	}
	
	
	public int size() {
		return lhs.size();
	}
	
	public Iterator<String> iterator() {
		return lhs.iterator();
	}

	
	/*
	 * getter + setter
	 */
	
	public int getLhsRhsSupp() {
		return lhsRhsSupp;
	}


	public int getLhsSupp() {
		return lhsSupp;
	}


	public double getValidity() {
		return validity;
	}


	public double getTotalCompleteness() {
		return totalCompleteness;
	}



	public String toString() {
		StringBuilder sb = new StringBuilder();
		sb.append(lhs).append(" -> INCLUDED_TRUE");
		sb.append(", lhsRhsSupp = ").append(lhsRhsSupp);
		sb.append(", lhsSupp = ").append(lhsSupp);
		sb.append(", validity = ").append(validity);
		sb.append(", totalCompleteness = ").append(totalCompleteness);
		
		return sb.toString();
	}
}
