package de.unipotsdam.hpi.cind.associationRuleMining.util;


/**
 * Represent a k-item-set and its frequency.
 * 
 * @author jana.bauckmann
 *
 */
public class ItemSet<E> {

	private Item<E>[] items;
	
	private int frequency;

//	private int size; 
	
	
	public ItemSet(Item<E>... items) {
		this.items = items;
		this.frequency = 0;
	}
	

	
	public void increaseFrequency() {
		this.frequency++;
	}
	

	public Item<E> getItem(int depth) {
		return items[depth];
	}
	
	/**
	 * 
	 * @return Number of items in this item set.
	 */
	public int getSize() {
		return items.length;
	}

	public boolean equals(Object o) {
		
		// TODO implement
		throw new RuntimeException("implement ItemSet.equals()!");
		
	}
	
	public int hashCode() {
		
		int hashCode = 0;
		for (int i = 0; i < items.length; i++) {
			hashCode += items[i].hashCode();
			
		}
		return hashCode / items.length;
	}
	
	public String toString() {
		StringBuffer sb = new StringBuffer();
		
		for (int i = 0; i < items.length-1; i++) {
			sb.append(items[i]).append(", ");
		}
		sb.append(items[items.length-1]);
		
		return sb.toString();
	}
}
