package de.unipotsdam.hpi.cind.unaryCondition;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.util.Arrays;
import java.util.HashMap;
import java.util.HashSet;
import java.util.LinkedList;
import java.util.List;
import java.util.Map;
import java.util.Set;



/**
 * 
 * @author benjamin.emde
 *
 */
public class CIndFinderParallel {

	public static void main(String[] args) {
		if (args.length < 4) {
			System.err.println("Usage: dep ref [complete|totally] maxConflicts");
			return;
		}
		
		String[] parts = args[0].split("\\.");
		String depSchema = parts[0];
		String depTable = parts[1];
		String depCol = parts[2];
		parts = args[1].split("\\.");
		String refSchema = parts[0];
		String refTable = parts[1];
		String refCol = parts[2];
		
		CIndFinder.V version = args[2].equals("totally") ? CIndFinder.V.TOTALLY : CIndFinder.V.COMPLETE;
		int maxConflicts = Integer.parseInt(args[3]);
		
		identifyCInd(depSchema, depTable, depCol,
				refSchema, refTable, refCol,
				version, maxConflicts);
	}
	

//	/**
//	 * @param refCol
//	 * @param refSchemaTable
//	 * @param depSchemaTable
//	 * @param depCol
//	 * @param condCol
//	 * @return valid & totally complete conditions for <code>condCol</code>
//	 * @throws SQLException
//	 */
//	private static Map<String,Object> detectCIndT(String refCol, String refSchemaTable,
//			String depSchemaTable, String depCol, List<String> condCols, int maxConflicts)
//			throws SQLException {
//		Statement stmt = con.createStatement();
//		ResultSet rs;
//		// select depCol, condCol, refCol, count(condCol) ...
//		rs = stmt.executeQuery(buildQuery(refSchemaTable, refCol,
//				depSchemaTable, depCol, condCols));
//
//		List<ConflictingTuple> conflictingTuples = new LinkedList<ConflictingTuple>();
//		
//		Object tCond = null;
//		Set<Object> aValues = new HashSet<Object>();
//		Set<Object> invalidConditions = new HashSet<Object>();
//		
//		Object a;
//		Object b = null;
//		Object c = null;
//		while (rs.next()) {
//			a = rs.getObject(2);
//			if (aValues.isEmpty()) {
//				b = rs.getObject(1);
//				c = rs.getObject(3);
//				if (c != null) {
//					tCond = a;
//				}
//			} else if (b.equals(rs.getObject(1))) {
//				if (c != null) {
//					conflictingTuples.add(new ConflictingTuple(condCol, a, b, c) );
//					if(conflictingTuples.size() > maxConflicts) {
//						return null;
//					}
//				}
//			} else {
//				if (c != null) {
//					if(!aValues.contains(tCond) || invalidConditions.contains(tCond)) {
//						conflictingTuples.add(new ConflictingTuple(condCol, Arrays.toString(aValues.toArray()), b, c) );
//						if(conflictingTuples.size() > maxConflicts) {
//							return null;
//						}
//					} else {
//						invalidConditions.clear();
//					}
//				} else if (c == null) {
//					if (aValues.contains(tCond)) {
//						conflictingTuples.add(new ConflictingTuple(condCol, tCond, b, c) );
//						if(conflictingTuples.size() > maxConflicts) {
//							return null;
//						}
//					} else {
//						invalidConditions.addAll(aValues);
//					}
//				}
//				aValues.clear();
//				b = rs.getObject(1);
//				c = rs.getObject(3);
//			}
//			aValues.add(a);
//		}
//		if ((c != null && (!aValues.contains(tCond) || invalidConditions.contains(tCond)))
//				|| (c == null && aValues.contains(tCond))) {
//			conflictingTuples.add(new ConflictingTuple(condCol, Arrays.toString(aValues.toArray()), b, c) );
//			if(conflictingTuples.size() > maxConflicts) {
//				return null;
//			}
//		}
//
//		for (ConflictingTuple conflictingTuple : conflictingTuples) {
//			System.out.println(conflictingTuple.toString());
//		}
//		
//		rs.close();
//		stmt.close();
//
//		if(tCond == null)
//			return "NULL";
//		
//		return tCond;
//	}

	public static int identifyCInd(String depSchema, String depTable,
			String depCol, String refSchema, String refTable, String refCol,
			CIndFinder.V version, int maxConflicts) {
		int count = 0;
		try {
			long start = System.currentTimeMillis();
			List<String> condCols = CIndFinder.queryCondCols(depSchema, depTable, depCol);
			
			if(condCols.size() == 0)
				return 0;
			
			// select depCol, condCol_1, condCol_2, ..., condCol_n, refCol ...
			ResultSet joinResult = Db.getInstance().con.createStatement().executeQuery(buildJoinQuery(refSchema + "." + refTable, refCol,
					depSchema + "." + depTable, depCol, condCols));
			
//			System.out.println("CIndFinderParallel processess " + condCols.size() + " condition-column candidates...");
				
			ResultSet rsCount = Db.getInstance().con.createStatement().executeQuery(CIndFinder.buildCountQuery(depSchema + "." + depTable, depCol));
			if(rsCount.next())
//				System.out.println(rsCount.getInt("AnzahlTupel") + " records in " + depSchemaTable + " - " + rsCount.getInt("AnzahlB") + " distinct values in " + depCol);
			
			if (version.equals(CIndFinder.V.TOTALLY)) {

//				Map<String,Object> tConds = detectCIndT(refCol, refSchemaTable,
//						depSchemaTable, depCol, condCols, maxConflicts);
//				
//				System.out.println("CIndFinderParallel found totally complete & valid cInds in: " + (System.currentTimeMillis() - start) + " ms");
//				
//				if(tCond != null)
//					System.out.println("Valid & Totally Complete Conditional INDs: " + condCol + " = \"" + tCond + "\"");
				//TODO
				
			} else if (version.equals(CIndFinder.V.COMPLETE)) {
				Map<String,Set<Object>> gConditions = identifyCIndC(joinResult, condCols, maxConflicts);
				
				
				for(Map.Entry<String,Set<Object>> e : gConditions.entrySet()) {
					count += e.getValue().size();
					for (Object cond : e.getValue()) {
						System.out.println("Valid & Complete Conditional INDs: " + e.getKey() + " = \"" + cond + "\"");
					}
				}
				
			}
			System.out.println(condCols.size() + ", " + rsCount.getInt("AnzahlTupel") + ", " + rsCount.getInt("AnzahlB") + ", " + count + ", " + (System.currentTimeMillis() - start));
			
			rsCount.close();
		} catch (Exception e) {
			e.printStackTrace();
		}
		return count;
	}


	/**
	 * @param joinResult
	 * @param condCol
	 * @return valid & complete conditions for <code>condCol</code>
	 * @throws SQLException
	 */
	private static Map<String,Set<Object>> identifyCIndC(ResultSet joinResult,
			List<String> condCols, int maxConflicts) throws SQLException {

		Map<String,Set<Object>> condCands = new HashMap<String,Set<Object>>();
		Map<String,Set<Object>> invalidConditions = new HashMap<String,Set<Object>>();
		Map<String,Set<Object>> aValues = new HashMap<String,Set<Object>>();
		
		Map<String,List<ConflictingTuple>> conflictingTuples = new HashMap<String,List<ConflictingTuple>>();
		
		List<String> aNames = new LinkedList<String>();
		aNames.addAll(condCols);
		List<String> tmpANames = new LinkedList<String>();
		tmpANames.addAll(condCols);
		
		Object b = null;
		Object c = null;
		
		Set<Object> curAValues;
		Object curB;
		Object curC;
		String aName;
		
		while (joinResult.next()) {
			curB = joinResult.getObject(1);
			if (curB == null)	// couldn't distinguish referring vs. non-referring (c==null in both cases)
				continue;
			curC = joinResult.getObject(2 + aNames.size());
			
			// iterate over condition-column candidates
			for (int i = 0; i < aNames.size(); i++) {
				aName = aNames.get(i);
				curAValues = aValues.get(aName);
				
				if (curAValues == null) {
					curAValues = new HashSet<Object>();
					
				} else if (! b.equals(curB)) {
					
					checkConflicts(maxConflicts, condCands,
							invalidConditions, conflictingTuples, tmpANames,
							b, c, curAValues, aName);
					
					curAValues.clear();
				}
				
				curAValues.add(joinResult.getObject(2 + i));
				aValues.put(aName, curAValues);
			}
			b = curB;
			c = curC;

			if(tmpANames.size() < aNames.size()) {	// check for discarded condition-column candidates
				aNames.clear();
				aNames.addAll(tmpANames);
			}
			
		}

		joinResult.close();

		for (int i = 0; i < aNames.size(); i++) {
			aName = aNames.get(i);
			curAValues = aValues.get(aName);
			
			checkConflicts(maxConflicts, condCands, invalidConditions,
					conflictingTuples, tmpANames, b, c, curAValues, aName);
		}
		if(tmpANames.size() < aNames.size()) {	// check for discarded condition-column candidates
			aNames.clear();
			aNames.addAll(tmpANames);
		}
		
		
//		List<ConflictingTuple> conTuples;
		for (int i = 0; i < aNames.size(); i++) {
			aName = aNames.get(i);
//			conTuples = conflictingTuples.get(condCol);
//			if (conTuples != null) {
//				for (ConflictingTuple conflictingTuple : conTuples) {
//					System.out.println(conflictingTuple.toString());
//				}
//			}
			
			if (condCands.get(aName).remove(null))
				condCands.get(aName).add("NULL");
		}

		Map<String,Set<Object>> conditions = condCands;
		
		return conditions;
	}

	private static void checkConflicts(int maxConflicts,
			Map<String, Set<Object>> condCands,
			Map<String, Set<Object>> invalidConditions,
			Map<String, List<ConflictingTuple>> conflictingTuples,
			List<String> tmpANames, Object b, Object c,
			Set<Object> curAValues, String aName) {
		
		Set<Object> specCondCands = condCands.get(aName);
		if (specCondCands == null)
			specCondCands = new HashSet<Object>();
		
		Set<Object> invConds = invalidConditions.get(aName);
		if (invConds == null)
			invConds = new HashSet<Object>();
		
		if ( !CIndFinder.updateConditionCandidates(specCondCands , curAValues, c, invConds ) ) {
			
			// conflict found for the condition "[aName] = [aValue]"
			List<ConflictingTuple> curConflictingTuples = conflictingTuples.get(aName);
			if (curConflictingTuples == null)
				curConflictingTuples = new LinkedList<ConflictingTuple>();
			
			curConflictingTuples.add( new ConflictingTuple(aName, Arrays.toString(curAValues.toArray()), b, c) );
			
			// check for maxConflicts
			if (curConflictingTuples.size() > maxConflicts) {
				// DISCARD the a-column [aName] as condition-column candidate 
				conflictingTuples.remove(aName);
				tmpANames.remove(aName);
				condCands.remove(aName);
				invalidConditions.remove(aName);
			} else {
				conflictingTuples.put(aName, curConflictingTuples);
			}
		} else {
			// save updated conditions
			condCands.put(aName, specCondCands);
			invalidConditions.put(aName, invConds);
		}
	}

	private static String buildJoinQuery(String refSchemaTable, String refCol,
			String depSchemaTable, String depCol, List<String> condCols) {
		StringBuilder b = new StringBuilder();
		b.append("select d.\"").append(depCol);
		
		for(String condCol : condCols) {
			b.append("\", d.\"").append(condCol);
		}
		
		b.append("\", r.\"").append(refCol).append("\" ");
		b.append("from ").append(depSchemaTable).append(" d left outer join ")
				.append(refSchemaTable).append(" r ");
		b.append("on d.\"").append(depCol).append("\" = r.\"").append(refCol).append(
				"\" ");
		b.append("order by d.\"").append(depCol).append("\"");
		return b.toString();
	}

}
