package de.unipotsdam.hpi.cind.associationRuleMining;

import java.util.*;

import de.unipotsdam.hpi.cind.associationRuleMining.util.*;

import junit.framework.*;

public class AprioriTest extends TestCase {

	ArrayList<Basket> baskets;
	
    /**
     * Constructor for AprioriTest.
     * @param arg0
     */
    public AprioriTest(String arg0) {
        super(arg0);
    }
	
    /**
     * @see TestCase#setUp()
     */
    protected void setUp() throws Exception {
        super.setUp();
        
    	/*
    	 * fill baskets
    	 */
        baskets = new ArrayList<Basket>();
        baskets.add( new Basket(Arrays.asList(Apriori.INCLUDED_TRUE, "B1", "C2", "D3")) ) ;
        baskets.add( new Basket(Arrays.asList(Apriori.INCLUDED_TRUE, "B1", "C2", "D4")) );
        baskets.add( new Basket(Arrays.asList(Apriori.INCLUDED_TRUE, "B1", "C3", "D5")) );
        baskets.add( new Basket(Arrays.asList(Apriori.INCLUDED_FALSE, "B1", "C2", "D6")) );
    	baskets.add( new Basket(Arrays.asList(Apriori.INCLUDED_FALSE, "B1", "C3", "D7")) );
        
    }
    
//    public void testApriori() {
//    	
//    	Apriori apriori = new Apriori(baskets, 2, 0.5, 0.5);
//    	
//    	HashMap<List<String>, Integer> frequentItemSets = apriori.findFrequentItemSets();
//    	for (List<String> currentItemSet : frequentItemSets.keySet()) {
//			System.out.println(currentItemSet + ": " + frequentItemSets.get(currentItemSet) + "x");
//		}
//    	System.out.println("size of frequentItemSets is " + frequentItemSets.size());
//    	
//    	ArrayList<AssociationRule> rules = apriori.generateAssociationRulesWithRhsTrue(frequentItemSets);
//    	System.out.println("found " + rules.size() + " rules");
//    	for (AssociationRule rule : rules) {
//			System.out.println(rule);
//		}
//    	
//    	
//    }
    
    
    public void testAllSubSetsFrequent() {
    	
    	Apriori apriori = new Apriori(baskets, 2, 0.5, 0.5);
    	
    	HashTreeNode frequentItemSets = new HashTreeNode();
    	frequentItemSets.addItemSet(new ItemSetString("A1", "B1", "C1"));
    	frequentItemSets.addItemSet(new ItemSetString("A1", "B1", "D1"));
    	frequentItemSets.addItemSet(new ItemSetString("A1", "C1", "D1"));
    	frequentItemSets.addItemSet(new ItemSetString("B1", "C1", "D1"));
    	
    	int itemSetSize = 3; 
    	ItemSetString candidate1 = new ItemSetString("A1", "B1", "C1", "D1");
    	ItemSetString candidate2 = new ItemSetString("A1", "B1", "C1", "D2");
    	
    	
    	assertTrue(apriori.allSubSetsFrequent(frequentItemSets, itemSetSize, candidate1));
    	assertFalse(apriori.allSubSetsFrequent(frequentItemSets, itemSetSize, candidate2));
    	
    	
    }
	
}
